#ifndef _SYS_STAT_H
#define _SYS_STAT_H

#include <sys/types.h>

struct stat {
	dev_t st_dev;				// ļ豸š
  	ino_t st_ino;				// ļi ڵš
 	umode_t st_mode;			// ļԣ棩
  	nlink_t st_nlink;			// ָļ
  	uid_t st_uid;				// ļû(ʶ)š
  	gid_t st_gid;				// ļš
  	dev_t st_rdev;				// 豸(ļַļļ)
  	off_t st_size;				// ļСֽļǳļ
  	time_t st_atime;			// ϴΣ󣩷ʱ䡣
  	time_t st_mtime;			// ޸ʱ䡣
  	time_t st_ctime;			// ڵ޸ʱ䡣
};

// Щst_mode ֵķơ
// ļͣ
#define S_IFMT 00170000		// ļͣ8 Ʊʾ
#define S_IFREG 0100000		// ļ
#define S_IFBLK 0060000		// ⣨豸ļdev/fd0
#define S_IFDIR 0040000		// Ŀ¼ļ
#define S_IFCHR 0020000		// ַ豸ļ
#define S_IFIFO 0010000		// FIFO ļ
// ļλ
#define S_ISUID 0004000		// ִʱûIDset-user-ID
#define S_ISGID 0002000		// ִʱID
#define S_ISVTX 0001000		// Ŀ¼ɾ־

#define S_ISREG(m) (((m) & S_IFMT) == S_IFREG)	// Ƿ񳣹ļ
#define S_ISDIR(m) (((m) & S_IFMT) == S_IFDIR)	// ǷĿ¼ļ
#define S_ISCHR(m) (((m) & S_IFMT) == S_IFCHR)	// Ƿַ豸ļ
#define S_ISBLK(m) (((m) & S_IFMT) == S_IFBLK)	// Ƿ豸ļ
#define S_ISFIFO(m) (((m) & S_IFMT) == S_IFIFO)	// ǷFIFO ļ

#define S_IRWXU 00700		// Զдִ/
#define S_IRUSR 00400		// ɡ
#define S_IWUSR 00200		// дɡ
#define S_IXUSR 00100		// ִ/ɡ

#define S_IRWXG 00070		// ԱԶдִ/
#define S_IRGRP 00040		// Աɡ
#define S_IWGRP 00020		// Աдɡ
#define S_IXGRP 00010		// Աִ/ɡ

#define S_IRWXO 00007		// ˶дִ/ɡ
#define S_IROTH 00004		// ˶ɡ
#define S_IWOTH 00002		// дɡ
#define S_IXOTH 00001		// ִ/ɡ

extern int chmod (const char *_path, mode_t mode);		// ޸ļԡ
extern int fstat (int fildes, struct stat *stat_buf);	// ȡָļļ״̬Ϣ
extern int mkdir (const char *_path, mode_t mode);		// Ŀ¼
extern int mkfifo (const char *_path, mode_t mode);		// ܵļ
extern int stat (const char *filename, struct stat *stat_buf);	// ȡָļļ״̬Ϣ
extern mode_t umask (mode_t mask);						// 롣
extern int lstat(const char *, struct stat *);
#endif
